> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Create automation

POST https://example.itential.io/operations-manager/automations
Content-Type: application/json

Creates a new Automation.

Reference: https://docs.itential.com/itential-cloud/api-reference/operations-manager/create-automation

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `name` (string, required) — The name of the document
- `description` (string, optional) — The description of the document
- `componentType` (any or any or any or any, optional, nullable) — The type of component linked to this Automation.
- `gbac` (object, optional)
  - `write` (list of string, required) — An array of group ids that have write access to the Automation.
  - `read` (list of string, required) — An array of group ids that have read/execute access to the Automation.
- `componentId` (string or string or any, optional, nullable) — The id of the component linked to this Automation.

## Response

### 200

The result of the create operation.

- `message` (string, required) — A human-readable message summarizing the result of the operation
- `data` (any, required) — Any successfully retrieved information related to the request.
- `metadata` (map from string to any, required) — Any structured, wordy or machine-readable information related to the result of the operation. For success responses, this may contain information like pagination values from a search operation.

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{
  "name": "Cisco IOS upgrade"
}
```

**Response**

```json
{
  "message": "Successfully created the requested item",
  "data": {
    "_id": "string",
    "componentId": "string",
    "componentType": null,
    "created": "2024-01-15T09:30:00Z",
    "createdBy": null,
    "description": "Turn up the port",
    "gbac": {
      "read": [
        "string"
      ],
      "write": [
        "string"
      ]
    },
    "lastUpdated": "2024-01-15T09:30:00Z",
    "lastUpdatedBy": null,
    "name": "Cisco IOS upgrade"
  },
  "metadata": {}
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/operations-manager/automations"

payload = { "name": "Cisco IOS upgrade" }
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/operations-manager/automations';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"name":"Cisco IOS upgrade"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/operations-manager/automations"

	payload := strings.NewReader("{\n  \"name\": \"Cisco IOS upgrade\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/operations-manager/automations")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Cisco IOS upgrade\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/operations-manager/automations")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Cisco IOS upgrade\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/operations-manager/automations', [
  'body' => '{
  "name": "Cisco IOS upgrade"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/operations-manager/automations");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Cisco IOS upgrade\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["name": "Cisco IOS upgrade"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/operations-manager/automations")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```